// ASMIX Commands and Utilities
// (c) Sergei Zubkov (Cubbi) 1999
//
// mkdir.s - Create Directories
// usage: mkdir path...
// TODO: mdir -m 044 a/ creates a with 755 and then a/ with 044 - fix that!
//
// $Id: mkdir.s,v 1.5 1999/10/06 20:52:34 cubbi Exp $
MKDIR_V_MAJ = 1
MKDIR_V_MIN = 0

.include "config.i"
	.globl _start
_start:
	cld
	popl	%ecx
// this was argc - 1 means we are called without arguments
	decl	%ecx
	jz	error_exit

// call umask(0) to get the current umask 
	xorl	%ebx,%ebx
.if SYSCALL_unix
	pushl	%ebx
	movl	$SYSCALL_UMASK,%eax
	pushl	%eax
        .byte   0x9A
        .long   0
        .word   7
	addl	$8,%esp
.endif
.if SYSCALL_linux
	movl	$SYSCALL_UMASK,%eax
	int	$0x80
.endif
// 0777 NAND umask
	notl	%eax
	andl	$0777,%eax
	movl	%eax,%ebp
.if OPTIONS
	movl	%eax,umask
.endif

	popl	%edi
// this is argv
arguments_cycle:
// skip argv[0]
	pushl	%ecx
	movl	$-1,%ecx
	xorl	%eax,%eax
	repne
	scasb
	popl	%ecx
// Checks for arguments
.if OPTIONS
	cmpb    $1,end_of_options
	je      skip_options
// Check for --
	cmpw    $0x2D2D,(%edi)
	jne     not_dashdash
	movb    $1,end_of_options
	loop    arguments_cycle
not_dashdash:
// Check for -options
.if FEATURE_VERSION
// Check for -V
	cmpw    $0x562D,(%edi)
	je      show_version
.endif
.if FEATURE_FULLOPT
// Check for -p
	cmpw    $0x702D,(%edi)
	jne     option_p_absent
	movb	$1,mode_minus_p
	incl    %esi
	loop    arguments_cycle
option_p_absent:
// Check for -m
	cmpw    $0x6D2D,(%edi)
	jne     option_m_absent
// lets parse the next argument as chmod(1) modes
	decl	%ecx
 // find start of the modestring
	pushl   %ecx
	movl    $-1,%ecx
	xorl    %eax,%eax
	repne
	scasb
	popl    %ecx

 // check if it's an octal number
 // and write it into %ebp (in where we kept the mask)
	cmpb	$0x30,(%edi)
	jb	not_octal
	cmpb	$0x37,(%edi)
	ja	not_octal

	xorl	%eax,%eax
	xorl	%edx,%edx
	xorl	%ebp,%ebp

continue_octal_to_hex:
	movb	(%edi),%al
	subb	$0x30,%al
	shll	$3,%ebp
	orl	%eax,%ebp

	cmpb	$0x30,1(%edi)
	jb	end_of_octal
	cmpb	$0x37,1(%edi)
	ja	end_of_octal

	incl	%edi
	jmp	continue_octal_to_hex

not_octal:
// remember if the character mode is used
	movb	$1,character_mode
	movl	%edi,character_mode_address

end_of_octal:
	decl	%ecx
	jnz	arguments_cycle
	
option_m_absent:
.endif
// exit with error message about unrecognized option
// and with the reminder about --
// TBD (if +errors)
// not an option -> options no more
	movb    $1,end_of_options
.endif

.if OPTIONS
//      loop    arguments_cycle
skip_options:
	jcxz	error_exit
.endif

// and now do the mkdir()
	pushl	%ecx
.if FEATURE_FULLOPT
	cmpb	$1,mode_minus_p
	jne	dumb_mode1
// find the end of the current parameter to substitute in the end
	pushl   %ecx
	pushl   %edi
	movl    $-1,%ecx
	xorl    %eax,%eax
	repne
	scasb
	movl    %edi,%edx
	popl    %edi
	popl    %ecx
	movl	%edi,start_of_path

dirname_loop:
	testl   %esi,%esi
	je      dumb_mode1
// save start
        pushl   %edi
// scan forward and replace first zero with slat if it's below end
        movl    %edx,%ecx
	subl	%edi,%ecx
	pushl	%ecx
        xorl    %eax,%eax
        repne
        scasb
	testl	%ecx,%ecx
	jz	scan_forward
        decl    %edi
        movb    $0x2F,(%edi)
scan_forward:
	popl	%ecx
// scan from start_of_path forward for '/'
	movl	start_of_path,%edi
        movb    $0x2F,%al
        repne
        scasb
// if we got to the end, finish with this argument
//      testl	%ecx,%ecx
//      jz      finished_path
// replace slat with zero if it's not beyond the end
	cmpl	%edi,%edx
	jb	skip_zeroing
        decl    %edi
        movb    $0,(%edi)
	incl	%edi
skip_zeroing:
	movl	%edi,start_of_path
// and mkdir again
        popl    %edi
dumb_mode1:
.endif
.if FEATURE_FULLOPT
// parse the character mode
// %ebp = umask
	cmpb	$1,character_mode
	jnz	no_character_mode
	movl	$0777,%eax
	movl	character_mode_address,%ebx
	movb	$1,chmod_parser_is_dir
	call	chmod_parser
	cmpl	$-1,%eax
	je	parser_error
	movl	%eax,%ebp
no_character_mode:
.endif
.if FEATURE_FULLOPT
// implement the required umask,u+wx mode for all intermediate dirs save last
	movl	%ebp,%ecx
	cmpb	$1,mode_minus_p
	jne	skip_mode_change
	cmpl	start_of_path,%edx
	jna	skip_mode_change
	movl	umask,%ecx
	orl	$0300,%ecx
skip_mode_change:
.endif
.if SYSCALL_unix
	pushl	%ecx
	pushl	%edi
	movl	$SYSCALL_MKDIR,%eax
	pushl	%eax
        .byte   0x9A
        .long   0
        .word   7
	addl	$12,%esp
.endif
.if SYSCALL_linux
	movl	%edi,%ebx
	movl	$SYSCALL_MKDIR,%eax
	int	$0x80
.endif

.if FEATURE_FULLOPT
	testl	%esi,%esi
	je	dumb_mode
	cmpl	start_of_path,%edx
	ja	dirname_loop
dumb_mode:
.endif
	popl	%ecx
        decl    %ecx
        jnz     arguments_cycle


// exit the program - exit(0)
exit:
	xorl	%ebx,%ebx
.if SYSCALL_unix
	pushl	%eax
	movl	$SYSCALL_EXIT,%eax
	pushl	%eax
        .byte   0x9A
        .long   0
        .word   7
.endif
.if SYSCALL_linux
	movl	$SYSCALL_EXIT,%eax
	int	$0x80
.endif

parser_error:
error_exit:
	xorl	%ebx,%ebx
	incl	%ebx
	movl	$SYSCALL_EXIT,%eax
.if SYSCALL_unix
        pushl   %ebx
        pushl   %eax
        .byte   0x9A
        .long   0
        .word   7
.endif
.if SYSCALL_linux
	int	$0x80
.endif

.if FEATURE_VERSION
show_version:
.if SYSCALL_unix
        pushl	$version_l
        pushl	$version
        pushl	$1
        movl	$SYSCALL_WRITE,%eax
        pushl	%eax
        .byte   0x9A
        .long   0
        .word   7
	addl	$16,%esp
.endif
.if SYSCALL_linux
        movl    $version_l,%edx
        movl    $version,%ecx
        movl    $1,%ebx
        movl    $SYSCALL_WRITE,%eax
        int     $0x80
.endif
        jmp     exit
.endif

	.data
.if OPTIONS
end_of_options:
	.byte   0
mode_minus_p:
	.byte	0
.endif
.if FEATURE_VERSION
version:
	.ascii  "mkdir.s "
	.byte   '0'+MKDIR_V_MAJ
	.ascii  "."
	.byte   '0'+MKDIR_V_MIN
	.ascii  "+version"
.if FEATURE_FULLOPT
	.ascii	"+options"
.endif
	.ascii  " ASMIX CU "
	.byte   '0'+ASMIX_VER_MAJ
	.ascii  "."
	.byte   '0'+ASMIX_VER_MIN
	.ascii  "."
	.byte   '0'+ASMIX_VER_REV
	.ascii  "\012"
version_l = .-version
.endif


	.bss
.if OPTIONS
	.lcomm umask,4
	.lcomm start_of_path,4
	.lcomm character_mode,1
	.lcomm character_mode_address,4
.endif


	.text
	.globl	print_al
print_al:
	pushl	%eax
	pushl	%edx
	movb	%al,%dl
	andb	$0x0F,%dl
	shrb	$4,%al
	cmpb	$10,%al
	sbbb	$0x69,%al
	das

	movb	%al,outbyte
	movb	%dl,%al
	cmpb	$10,%al
	sbbb	$0x69,%al
	das
	movb	%al,outbyte+1

	movl	$outbyte_l,%edx
	movl	$outbyte,%ecx
	movl	$1,%ebx
	movl	$4,%eax
	int	$0x80
	
	popl	%edx
	popl	%eax
	ret

	.data
outbyte:
	.ascii	"00\012"
outbyte_l = .-outbyte

