#!/bin/sh
# $Id: test-basename.sh,v 1.1 1999/10/07 04:26:00 cubbi Exp $
TESTPROG=`pwd`/../bin/basename

# Test 0: check if it exists
if test ! -f $TESTPROG; then
        echo "failed: $TESTPROG doesn't exist"
        exit
fi

echo -n "Testing `basename $TESTPROG`... "
# Test 1: 
if test `$TESTPROG  aaa/bbb` != "bbb"; then
	echo "failed: did not solve trivial case"
	exit
fi
# Test 2: 
if test `$TESTPROG  //////` != "/"; then
	echo "failed: did not reduce ////// to sing slash"
	exit
fi
# Test 3:
if test `$TESTPROG  aaa/bbb//////` != "bbb"; then
	echo "failed: did not remove trailing slashes"
	exit
fi
# Test 4:
if test `$TESTPROG  aaa` != "aaa"; then
	echo "failed: modified a single argument"
	exit
fi
# Test 5:
if test `$TESTPROG  foo.c .c` != "foo"; then
	echo "failed: did not strip a suffix"
	exit
fi
# Test 6:
if test `$TESTPROG  foo.c//////////// .c` != "foo"; then
	echo "failed: did not strip a suffix shielded with slashes"
	exit
fi


if $TESTPROG a/b >/dev/null; then
	echo passed
else
	echo "failed: did not return true"
fi

