#!/bin/sh
# $Id: test-dirname.sh,v 1.2 1999/10/07 04:26:00 cubbi Exp $
TESTPROG=`pwd`/../bin/dirname

# Test 0: check if it exists
if test ! -f $TESTPROG; then
        echo "failed: $TESTPROG doesn't exist"
        exit
fi

echo -n "Testing `basename $TESTPROG`... "
# Test 1: 
if test `$TESTPROG  aaa/bbb` != "aaa"; then
	echo "failed: did not solve trivial case"
	exit
fi
# Test 2: 
if test `$TESTPROG  //////` != "/"; then
	echo "failed: did not reduce ////// to sing slash"
	exit
fi
# Test 3:
if test `$TESTPROG  aaa/bbb//////` != "aaa"; then
	echo "failed: did not remove trailing slashes"
	exit
fi
# Test 4:
if test `$TESTPROG  aaa` != "."; then
	echo "failed: did not change aaa into ."
	exit
fi
# Test 5:
if test `$TESTPROG  aaa///////////` != "."; then
	echo "failed: did not change aaa///////// into ."
	exit
fi
# Test 6:
if test `$TESTPROG  //////////` != "/"; then
	echo "failed: did not change ////////// into /"
	exit
fi
# Test 7:
if test `$TESTPROG  //////aaa` != "/"; then
	echo "failed: did not change //////aaa into /"
	exit
fi
# tests from the UNIX2 man page
if test `$TESTPROG  /` != "/"; then
	echo "failed: did not change / into /"
	exit
fi
if test `$TESTPROG  /a/b/` != "/a"; then
	echo "failed: did not change /a/b/ into /a"
	exit
fi
if test `$TESTPROG  //a//b//` != "//a"; then
	echo "failed: did not change //a//b// into //a"
	exit
fi
if test `$TESTPROG  a` != "."; then
	echo "failed: did not change a into ."
	exit
fi
if test `$TESTPROG  /a` != "/"; then
	echo "failed: did not change /a into /"
	exit
fi
if test `$TESTPROG  /a/b` != "/a"; then
	echo "failed: did not change /a/b into /a"
	exit
fi
if test `$TESTPROG  a/b` != "a"; then
	echo "failed: did not change a/b into a"
	exit
fi

if $TESTPROG a/b >/dev/null; then
	echo passed
else
	echo "failed: did not return true"
fi

